﻿-- Config UI

local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceDB = LibStub("AceDB-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")

function SN:SetupOptions()
	SN.options.args.profile = AceDBOptions:GetOptionsTable(SN.db)
	
	AceConfig:RegisterOptionsTable("SN", SN.options, nil)
	
	SN.optionsFrames = {}
	SN.optionsFrames.general = AceConfigDialog:AddToBlizOptions("SN", "Serenity Now", nil, "general")
end

SN.TexCoords = {.08, .92, .08, .92}

SN.V.defaults = {
	profile = {
		["CD"] = {
			castannounce = true,
			cdannounce = false,
			clickannounce = false,
			show = "always",
			justyou = false,
			raid = true,
		},
		["Frames"] = {
			lock = true,
		},
		["powerbar"] = {
			["hunter"] = {
				{	--Beast Mastery
					{ true, "Kill Command", true, false, {1,1,1,1}, 0 },
					{ false, "Glaive Toss", true, false, {1,1,1,1}, 0 },
				},
				{	--Marksman
					{ true, "Chimera Shot", true, false, {1,1,1,1}, 0 },
					{ false, "Aimed Shot", true, false, {1,1,1,1}, 0 },
				},
				{	--Survival
					{ true, "Explosive Shot", true, false, {1,1,1,1}, 0 },
					{ false, "Black Arrow", true, false, {1,1,1,1}, 0 },
				},
			},
			["rogue"] = {
				{	--Assassination
					{ true, "Mutilate", true, false, {1,1,1,1}, 0 },
					{ false, "Dispatch", true, false, {1,1,1,1}, 0 },
				},
				{	--Combat
					{ true, "Sinister Strike", true, false, {1,1,1,1}, 0 },
					{ false, "Eviscerate", true, false, {1,1,1,1}, 0 },
				},
				{	--Subtlety
					{ true, "Backstab", true, false, {1,1,1,1}, 0 },
					{ false, "Eviscerate", true, false, {1,1,1,1}, 0 },
				},
			},
			["druid"] = {
				{	--Feral
					{ true, "Shred", true, false, {1,1,1,1}, 0 },
					{ false, "Mangle", true, false, {1,1,1,1}, 0 },
				},
				{	--Guardian
					{ true, "Savage Defense", true, false, {1,1,1,1}, 0 },
					{ false, "Frenzied Regeneration", true, false, {1,1,1,1}, 0 },
				},
			},
			["warrior"] = {
				{	--Arms
					{ true, "Slam", true, false, {1,1,1,1}, 0 },
					{ false, "Execute", true, false, {1,1,1,1}, 0 },
				},
				{	--Fury
					{ true, "Heroic Strike", true, false, {1,1,1,1}, 0 },
					{ false, "Execute", true, false, {1,1,1,1}, 0 },
				},
				{	--Prot
					{ true, "Shield Block", true, false, {1,1,1,1}, 0 },
					{ false, "Shield Barrier", true, false, {1,1,1,1}, 0 },
				},
			},
		},
	},
}

SN.options =  {
	type = "group",
	name = "Serenity Now",
	args = {
		general = {
			order = 1,
			type = "group",
			name = "General Settings",
			cmdInline = true,
			args = {
				castannounce = {
					type = "toggle",
					name = "Announce Casts",
					order = 2,
					get = function()
						return SN.V.defaults.profile.CD.castannounce
					end,
					set = function(key, value)
						SN.V.defaults.profile.CD.castannounce = value
					end,
				},		
				cdannounce = {
					type = "toggle",
					name = "Announce CD Expire",
					order = 3,
					get = function()
						return SN.V.defaults.profile.CD.cdannounce
					end,
					set = function(key, value)
						SN.V.defaults.profile.CD.cdannounce = value
					end,
				},		
				lock = {
					order = 7,
					name = "Lock Frames",
					type = 'toggle',
					get = function()
						return SN.V.defaults.profile.Frames.lock 
					end,
					set = function(key, value)
						SN.V.defaults.profile.Frames.lock = value
						SN:MoveFrames(value)
					end,
				},	
			},
		},
	},
}